#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>
#include <windows.h>

const int INITIAL_OFFSET = 4100;
const int SEARCH_WIDTH = 2500;
const int INITIAL_MAX = (SEARCH_WIDTH*16);//40000
//INITIAL_MAX + INITIAL_OFFSET = 44100 = 1.0sec
const int WAV_MAX = 10;
const double PI = 3.14159265358979;

struct wav_common{
 double *initials;
 double gain;
 double score;
 int offset;
 int file_offset;
 int is_float;
};

int init_wav_common(struct wav_common *wc){
 wc->gain = 1.0;
 wc->score = 0.0;
 wc->offset = 0;
 wc->file_offset = 0;
 wc->initials = (double *)malloc(sizeof(double)*INITIAL_MAX);
 if(wc->initials == NULL)exit(0);
 wc->is_float = 0;
 return 0;
}


int wav_gainoffset_search(struct wav_common *wo,struct wav_common *wc){
 int i,j,k;
 int offset;
 double bestscore = 0.0;
 double score;
 double bestamp = 0.0;
 int bestoffset = 0;
 double rmsampo = 0.0;
 for(i=SEARCH_WIDTH;i<SEARCH_WIDTH*13;i++){
  rmsampo += (wo->initials[i])*(wo->initials[i]);
 }
 rmsampo = sqrt(rmsampo);
 for(offset=-SEARCH_WIDTH;offset<SEARCH_WIDTH*3;offset++){
  double rmsampc = 0.0;
  for(i=SEARCH_WIDTH;i<SEARCH_WIDTH*13;i++){
   rmsampc += (wc->initials[offset+i])*(wc->initials[offset+i]);
  }
  rmsampc = sqrt(rmsampc);
  if(rmsampc==0.0){
   printf("No Sound At All.\r\n");
   return 0;
  }
  double theamp = rmsampo/rmsampc;
  score = 0.0;
  for(i=SEARCH_WIDTH;i<SEARCH_WIDTH*13;i++){
   double error_wav = wc->initials[offset+i]*theamp-wo->initials[i];
   score += error_wav*error_wav;
  }
  score = sqrt(score);
  score /= rmsampo;
  if(offset+SEARCH_WIDTH==0 || score<bestscore){
   bestscore = score;
   bestamp = theamp;
   bestoffset = offset;
  }
 }
 //printf("bestoffset : %d    ",bestoffset);
 //printf("bestamp    : %f\r\n",bestamp);
 wc->gain = bestamp;
 wc->offset = bestoffset;
 wc->score = bestscore;
 return 0;
}



main(int argc, char **argv){
 char wav_path[WAV_MAX][2048];
 int i,j,k,l;
 int input_wav_length = 0x7FFFFFFF;
 int input_sampling_rate;
 int intbuf;
 float flobuf;

 int wav_num;

 short sbuf;
 FILE WAV[WAV_MAX];
 FILE *wav[WAV_MAX];
 struct wav_common WAVC[WAV_MAX];
 struct wav_common *wavc[WAV_MAX];
 for(i=0;i<WAV_MAX;i++){
  wav[i] = &WAV[i];
  wavc[i] = &WAVC[i];
  init_wav_common(wavc[i]);
 }

 if(argc<3){
  printf("Abc/hr raw generator ver.1.1.0 (http://d.hatena.ne.jp/kamedo2/)\r\n");
  printf(" Equalize offset and gain of 32bit float or int 44100Hz wav files.\r\n");
  printf("  Then output them as raw, to perform an abc/hr test.\r\n\r\n");
  printf("    usage:  rawgene original.wav lossy1.wav lossy2.wav.....\r\n\r\n");
  printf("detectable offset: %d ~ %d[sample]. Yulewalk filter for 44.1k is used.\r\n",-SEARCH_WIDTH,SEARCH_WIDTH*3-1);
  return 0;
 }
 else{
  printf("rawgene v.1.1.0  /  original reference file:%s\r\n",argv[1]);
  wav_num = argc-1;
  if(wav_num>WAV_MAX){
   printf("Too many lossy files : wav_num:%d.\r\n",wav_num);
   return 1;
  }
  for(i=0;i<wav_num;i++){
   strcpy(wav_path[i],argv[1+i]);
   wav[i] = fopen(wav_path[i],"rb");
   if(wav[i]==NULL){
    printf("Cannot open this file : %s.\r\n",wav_path[i]);
    return 2;
   }
   char chunkstr[8] = {0};
   int chunk_length;
   int chunk_max = 10;
   
   fread(chunkstr,1,4,wav[i]);
   if(strcmp(chunkstr,"RIFF")!=0){
    printf("RIFF != %s\r\n",chunkstr);
    printf("Not a valid RIFF WAV File: %s\r\n",wav_path[i]);
    return 3;
   }
   fread(chunkstr,1,4,wav[i]);
   fread(chunkstr,1,4,wav[i]);
   if(strcmp(chunkstr,"WAVE")!=0)printf("WAVE != %s\r\n",chunkstr);
   fread(chunkstr,1,4,wav[i]);
   while(strcmp(chunkstr,"fmt ")!=0 && (chunk_max>0)){
    printf("skipped unknown chunk '%s' while searching 'fmt '.\r\n",chunkstr);
    fread(&chunk_length,4,1,wav[i]);
    for(j=0;j<chunk_length;j++)fread(chunkstr,1,1,wav[i]);
    fread(chunkstr,1,4,wav[i]);
    chunk_max--;
   }
   if(chunk_max==0){
    printf("Chunks too much.\r\n");
    return 3;
   }
   fread(&chunk_length,4,1,wav[i]);
   fread(chunkstr,1,4,wav[i]);
   int wav_type = (chunkstr[1]<<8)|chunkstr[0];

   if((chunkstr[0]!=1 || chunkstr[1]!=0) && (chunkstr[0]!=-2 || chunkstr[1]!=-1)){
    if(wav_type!=0x0001 && wav_type!=0xFFFE && wav_type!=0x0003){
     printf("This is not a linear(integer) or float PCM. %d\r\n",wav_type);//WAVE_FORMAT_EXTENSIBLE
     return 4;//not linear or float PCM
    }
   }
   if(wav_type==0x0003)wavc[i]->is_float = 1;
   if(chunkstr[3]!=0 || chunkstr[2]!=2){
    printf("This is not a stereo file.\r\n");
    return 5;//channel number error.
   }
   fread(&input_sampling_rate,1,4,wav[i]);
   if(input_sampling_rate!=44100){
    printf("Note: using sample rate other than 44.1kHz is not recommended.\r\n");
   }
   fread(&intbuf,1,4,wav[i]);
   if(intbuf!=input_sampling_rate*8){
    printf("This is not a 32bit depth wave file.\r\n");
    return 6;//16bit,24bit...etc
   }
   for(j=0;j<chunk_length-12;j++)fread(chunkstr,1,1,wav[i]);
   //printf("%d fmt complete\r\n",i);

   fread(chunkstr,1,4,wav[i]);
   while(strcmp(chunkstr,"data")!=0 && (chunk_max>0)){
    printf("skipped unknown chunk '%s' while searching 'data'.\r\n",chunkstr);
    fread(&chunk_length,4,1,wav[i]);
    for(j=0;j<chunk_length;j++)fread(chunkstr,1,1,wav[i]);
    fread(chunkstr,1,4,wav[i]);
    chunk_max--;
   }
   if(chunk_max==0){
    printf("There are no data chunk.\r\n");
    return 7;
   }
   fread(&intbuf,4,1,wav[i]);
   if(intbuf<input_wav_length)input_wav_length = intbuf;
  }
 }
 input_wav_length /= 8;
 printf("input_wav_length : %d\r\n",input_wav_length);
 if(input_wav_length<INITIAL_OFFSET+INITIAL_MAX){
   printf("INPUT FILES TOO SHORT.\r\n");
   return 8;
 }
 //"Yulewalk" filter
 double iir_l_left[10];
 double iir_l_right[10];
 double iir_b_left[10];
 double iir_b_right[10];

 for(i=0;i<wav_num;i++){
  wavc[i]->file_offset = (int)ftell(wav[i]);
  double dbuf;
  double cap1,cap0;
  for(k=0;k<10;k++){
   iir_l_left[k] = iir_l_right[k] = 0;
   iir_b_left[k] = iir_b_right[k] = 0;
  }
  for(j=0;j<INITIAL_OFFSET+INITIAL_MAX;j++){
   if(wavc[i]->is_float){
    fread(&flobuf,4,1,wav[i]);
    dbuf = (double)flobuf;
    fread(&flobuf,4,1,wav[i]);
    dbuf += (double)flobuf;
   }
   else{
    fread(&intbuf,4,1,wav[i]);
    dbuf = (double)intbuf;
    fread(&intbuf,4,1,wav[i]);
    dbuf += (double)intbuf;
    dbuf /= 2147483648.0;//32bit 2^31
   }

   //dbuf = ((rand()&1)-0.5)*10000000000.0;

   cap0 = dbuf*0.98500175787242;
   cap0 -= iir_b_left[0]*1.97000351574484;
   cap0 += iir_b_left[1]*0.98500175787242;
   iir_b_left[1] = iir_b_left[0];
   iir_b_left[0] = dbuf;
   cap0 += iir_b_right[0]*1.96977855582618;
   cap0 -= iir_b_right[1]*0.97022847566350;
   iir_b_right[1] = iir_b_right[0];
   iir_b_right[0] = cap0;

   cap1 = cap0*0.05418656406430;

   cap1 -= iir_l_left[0]*0.02911007808948;
   cap1 -= iir_l_left[1]*0.00848709379851;
   cap1 -= iir_l_left[2]*0.00851165645469;
   cap1 -= iir_l_left[3]*0.00834990904936;
   cap1 += iir_l_left[4]*0.02245293253339;
   cap1 -= iir_l_left[5]*0.02596338512915;
   cap1 += iir_l_left[6]*0.01624864962975;
   cap1 -= iir_l_left[7]*0.00240879051584;
   cap1 += iir_l_left[8]*0.00674613682247;
   cap1 -= iir_l_left[9]*0.00187763777362;
   iir_l_left[9] = iir_l_left[8];
   iir_l_left[8] = iir_l_left[7];
   iir_l_left[7] = iir_l_left[6];
   iir_l_left[6] = iir_l_left[5];
   iir_l_left[5] = iir_l_left[4];
   iir_l_left[4] = iir_l_left[3];
   iir_l_left[3] = iir_l_left[2];
   iir_l_left[2] = iir_l_left[1];
   iir_l_left[1] = iir_l_left[0];
   iir_l_left[0] = cap0;
   cap1 += iir_l_right[0]*3.47845948550071;
   cap1 -= iir_l_right[1]*6.36317777566148;
   cap1 += iir_l_right[2]*8.54751527471874;
   cap1 -= iir_l_right[3]*9.47693607801280;
   cap1 += iir_l_right[4]*8.81498681370155;
   cap1 -= iir_l_right[5]*6.85401540936998;
   cap1 += iir_l_right[6]*4.39470996079559;
   cap1 -= iir_l_right[7]*2.19611684890774;
   cap1 += iir_l_right[8]*0.75104302451432;
   cap1 -= iir_l_right[9]*0.13149317958808;
   iir_l_right[9] = iir_l_right[8];
   iir_l_right[8] = iir_l_right[7];
   iir_l_right[7] = iir_l_right[6];
   iir_l_right[6] = iir_l_right[5];
   iir_l_right[5] = iir_l_right[4];
   iir_l_right[4] = iir_l_right[3];
   iir_l_right[3] = iir_l_right[2];
   iir_l_right[2] = iir_l_right[1];
   iir_l_right[1] = iir_l_right[0];
   iir_l_right[0] = cap1;

   if(j>=INITIAL_OFFSET){
    wavc[i]->initials[j-INITIAL_OFFSET] = cap1;
   }
  }
 }
 int biggest_delay = 0;
 int smallest_delay = 0;
 double biggest_gain = 1.0;
 for(i=1;i<wav_num;i++){
  wav_gainoffset_search(wavc[0],wavc[i]);
  if(wavc[i]->offset<smallest_delay)smallest_delay = wavc[i]->offset;
  if(biggest_delay<wavc[i]->offset)biggest_delay = wavc[i]->offset;
  if(biggest_gain<wavc[i]->gain)biggest_gain = wavc[i]->gain;

  if(wavc[i]->is_float==1)printf("FLO %d:",i);
  if(wavc[i]->is_float==0)printf("INT %d:",i);
  printf("Offset:%5d  ",wavc[i]->offset);
  printf("  Gain:%f  ",wavc[i]->gain);
  printf("  Gain:%f[dB]   ",20.0*log10(wavc[i]->gain));
  printf(" Score:%f   \r\n",wavc[i]->score);
 }
 input_wav_length -= (biggest_delay-smallest_delay);
 printf("biggest_delay    : %d\r\n",biggest_delay);
 printf("smallest_delay   : %d\r\n",smallest_delay);
 printf("biggest_gain     : %f\r\n",biggest_gain);
 printf("input_wav_length : %d\r\n",input_wav_length);

 for(i=0;i<wav_num;i++){
  fseek(wav[i],wavc[i]->file_offset+(wavc[i]->offset-smallest_delay)*8,SEEK_SET);
  FILE *rawout;
  char *sp = strstr(wav_path[i],".32b.wav");
  if(sp!=NULL)sp[0] = '\0';
  strcat(wav_path[i],".raw");
  rawout = fopen(wav_path[i],"wb");
  if(rawout==NULL){
   printf("Output path is not available.\r\n");
   return 9;
  }
  double thegain = wavc[i]->gain*32768.0/(biggest_gain*1.1);
  int clipped = 0;
  for(j=0;j<input_wav_length*2;j++){
   if(wavc[i]->is_float){
    fread(&flobuf,4,1,wav[i]);
   }
   else{
    fread(&intbuf,4,1,wav[i]);
    flobuf = intbuf/2147483648.0;//32bit 2^31
   }
   int ibtg = (int)(100000.0+flobuf*thegain)-100000;
   if(ibtg<-32500 || 32500<ibtg){
    clipped++;
    if(ibtg<-32700)ibtg = -32700;
    if(ibtg>32700)ibtg = 32700;
   }
   char cbuf;
   cbuf = ibtg&0xFF;
   fwrite(&cbuf,1,1,rawout);
   cbuf = ibtg>>8;
   fwrite(&cbuf,1,1,rawout);
  }
  //printf("i:%d  ",i);
  if(clipped){
   if(wavc[i]->is_float==1)printf("FLO %d: Clipped %d times.\r\n",i,clipped);
   if(wavc[i]->is_float==0)printf("INT %d: Clipped %d times.\r\n",i,clipped);
  }
  //printf("\r\n");
  free(wavc[i]->initials);
  wavc[i]->initials = NULL;
  fclose(wav[i]);
 }


 /*
 FILE *output_wav;
 output_wav = fopen("test_originial.wav","wb");
 if(output_wav==NULL){
  printf("Output path is not available.\r\n");
  return 10;
 }
 fputs("RIFF",output_wav);
 intbuf = 44-8+INITIAL_MAX*8;
 fwrite(&intbuf,4,1,output_wav);
 fputs("WAVE",output_wav);
 fputs("fmt ",output_wav);
 intbuf = 16;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536*2+1;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = input_sampling_rate;
 fwrite(&intbuf,4,1,output_wav);
 intbuf *= 2*4;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536*32+2*4;
 fwrite(&intbuf,4,1,output_wav);
 fputs("data",output_wav);
 intbuf = INITIAL_MAX*8;
 fwrite(&intbuf,4,1,output_wav);

 for(i=0;i<INITIAL_MAX;i++){
  for(j=0;j<2;j++){
   int s = wavc[0]->initials[i];
   fwrite(&s,4,1,output_wav);
  }
 }
 fclose(output_wav);
 */
 Sleep(1000); 
 return 0;
}

